const {app, protocol} = require('electron');

const path     = require('path');

/* 
 *  local:// — File protocol registration
 * 
 *  This protocol allows to access the user document 
 *  directory where iolab data are stored
 */
protocol.registerFileProtocol('local',
    function(request, callback) {
        let url = path.normalize(request.url.substr('local'.length + 3));
        
        let pathResources = path.join(__dirname, '..', 'resources');

        let pathActivities = path.join(app.getPath('documents'), 'IOLab-WorkFiles', 'activities');

        let pathReports = path.join(app.getPath('documents'), 'IOLab-WorkFiles', 'reports');

        if (url.indexOf(pathReports) < 0 &&
            url.indexOf(pathResources) < 0 &&
            url.indexOf(pathActivities) < 0) {
            throw new Error('You are not authorized to access this resource!\n' + url);
        }

        callback({path: path.normalize(url)});
    },
    function (error) { if (error) throw error; }
);

module.exports = {};